'use strict';

exports.__esModule = true;
exports.extractCritical = extractCritical;

var _foreach = require('@arr/foreach');

var _foreach2 = _interopRequireDefault(_foreach);

var _filter = require('@arr/filter.mutate');

var _filter2 = _interopRequireDefault(_filter);

var _index = require('./index');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RGX = /css(?:[a-zA-Z0-9-]*)-([a-zA-Z0-9]+)/gm;

function extractCritical(html) {
  // parse out ids from html
  // reconstruct css/rules/cache to pass
  var o = { html: html, ids: [], css: '', rules: [] };
  var match = void 0;
  var ids = {};
  while ((match = RGX.exec(html)) !== null) {
    if (!ids[match[1]]) {
      ids[match[1]] = true;
    }
  }

  o.rules = (0, _filter2.default)(_index.sheet.sheet.cssRules.slice(), function (x) {
    var match = RGX.exec(x.cssText);
    return match == null || ids[match[1]] || false;
  });

  o.ids = (0, _filter2.default)((0, _utils.keys)(_index.inserted), function (id) {
    return !!ids[id];
  });

  var css = '';
  (0, _foreach2.default)(o.rules, function (x) {
    return css += x.cssText;
  });
  o.css = css;

  return o;
}